;
;   Takt = T(Period)/Cycle  = 100ms/8s 
;
;
;
;
;
;
	Device = 16F628A

	Declare Reminders Off                            
	@ CONFIG_REQ = 0 ; 
	Asm-
	__Config  0x3F62 ;FOSC_HS & WDTE_OFF & PWRTE_ON & MCLRE_ON & BOREN_ON & LVP_OFF & CPD_OFF & CP_OFF 
	Endasm-
	Declare Reminders On


Xtal = 20


All_Digital = 1

Symbol Data = PORTB.4
Symbol Clock = PORTB.5


Symbol ConstFr = ((20000000 / 4) / 8) * 16   ;     
Symbol ConstP  = 14.529   ; ,   1 
;      
 


Dim Timer1 As TMR1L.Word   ; 16-    1

Symbol RBIF = INTCON.0 ' RB Port Interrupt Flag
Symbol INTF = INTCON.1 ' RB0 External Interrupt Flag
Symbol T0IF = INTCON.2 ' TMR0 Overflow Interrupt Flag
Symbol RBIE = INTCON.3 ' RB Port Change Interrupt Enable
Symbol INTE = INTCON.4 ' RB0 External Interrupt Enable
Symbol T0IE = INTCON.5 ' TMR0 Overflow Interrupt Enable
Symbol PEIE = INTCON.6 ' Peripheral Interrupt Enable
Symbol GIE = INTCON.7  ' Global Interrupt Enable

Symbol TMR1IF = PIR1.0 ' TMR1 Overflow Interrupt Flag bit
Symbol TMR2IF = PIR1.1 ' TMR2 to PR2 Match Interrupt Flag
Symbol CCP1F = PIR1.2  ' CCP1 Interrupt Flag
Symbol TXIF = PIR1.4   ' USART Transmit Interrupt Flag
Symbol RCIF = PIR1.5   ' USART Receive Interrupt Flag
Symbol CMIF = PIR1.6   ' Comparator Interrupt Flag
Symbol EEIF = PIR1.7   ' EEPROM Write Operation Interrupt Flag

Symbol TMR1IE = PIE1.0 ' TMR1 Overflow Interrupt Enable
Symbol TMR2IE = PIE1.1 ' TMR2 to PR2 Match Interrupt Enable
Symbol CCP1IE = PIE1.2 ' CCP1 Interrupt Enable
Symbol TXIE = PIE1.4   ' USART Transmit Interrupt Enable
Symbol RCIE = PIE1.5   ' USART Receive Interrupt Enable
Symbol CMIE = PIE1.6   ' Comparator Interrupt Enable
Symbol EEIE = PIE1.7   ' EE Write Complete Interrupt Enable



Dim CAPTURE As Dword ;     
Dim Freq As Word   ;
Symbol HFreq = CAPTURE.Word1

Dim DigitSel As Byte;      
Dim digit As Byte
Dim digits As Byte
Dim Dig7Seg As Byte
Dim Dig1 As Byte;
Dim Dig2 As Byte;
Dim Dig3 As Byte;
Dim Dig4 As Byte;
Dim Address As Byte;
Dim EnDisp As Bit;

Dim OverFr As Byte


On_Interrupt GoTo INTER

PORTA = 0
PORTB = 0
TRISA = 0
TRISB = %00001000


T1CON = %00111001
CCP1CON = %00000111  ;      
CCP1IE = 1 ;   
Timer1 = 0;
TMR1IE = 1;
T0IE = 1;    0
TMR0 = 0;
OPTION_REG = %10000110

PEIE = 1
GIE = 1

DigitSel = %00000001
Address = VarPtr(Dig1)



GoTo main

INTER:
 Context Save

    If CCP1F = 1 Then     ;    
    CAPTURE = Timer1 + 1    ;     
    HFreq = HFreq + OverFr
    OverFr = 0
    Timer1 = 0
    CCP1F = 0            ;   .  
    
   EndIf 
 
   If T0IF = 1 Then      ;    0
       EnDisp = 1;
       T0IF = 0
   EndIf
   
   If TMR1IF = 1 Then    ;    
      OverFr = OverFr + 1
      TMR1IF = 0
   EndIf   
    

 
 Context Restore


 main:
 
 Freq =  ConstFr/CAPTURE   ;  
 Freq = Freq / ConstP      ;   
; DelayMS 300

 Dig7Seg = Dig Freq, 3
 GoSub LOOK
 Dig1 = digit 
 
 Dig7Seg = Dig Freq, 2
 GoSub LOOK
 Dig2 = digit 
 
 Dig7Seg = Dig Freq, 1
 GoSub LOOK
 Dig3 = digit 
 
 Dig7Seg = Dig Freq, 0
 GoSub LOOK
 Dig4 = digit 
 
 If EnDisp = 1 Then     ;    
    EnDisp = 0
    GoSub OnDisplay
 EndIf   


 GoTo main
 
 LOOK:

  ;                           0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 ,  
  digit = LookUpL Dig7Seg,[0x3F,0x6,0x5B,0x4F,0x66,0x6D,0x7,0x7F,0x6F]         
Return

OnDisplay:
      PORTA = %00001111
      
       FSR = Address                         ;  
       digits = INDF                         ; -------------------
       SHOut Data, Clock, MsbFirst, [digits] 
       PORTA = ~DigitSel
       
       DigitSel = DigitSel << 1
       Inc Address
       
       If DigitSel = %00010000 Then
          DigitSel = %00000001
          Address = VarPtr(Dig1)
       EndIf
    Return   

 
 End;

